@set @x=0 /*
@echo off
setlocal enableextensions disabledelayedexpansion

set Min10Ver=1703
set Min10Build=15063
set MinAIBuild=17134

set FSName=24831TIRRSOFT.FS
set FSCSuf=7dqv9t6ww56qc
set AIName=Microsoft.DesktopAppInstaller
set StoreSuf=8wekyb3d8bbwe
set "RepURL=https://fsclient.github.io/fs"
set FNames=FSClient.UWP
set curlcrt="%~dp0bin\curl-ca-bundle.crt"
set "PS=powershell -NoLogo -NoProfile -NonInteractive -InputFormat None -ExecutionPolicy Bypass -Command"
set curl="%~dp0bin\curl.exe"
set grep="%~dp0bin\grep.exe"
set sed="%~dp0bin\sed.exe"
set p7z="%~dp0bin\7za.exe"
set xml="%~dp0bin\xml.exe"

for /f "tokens=2 delims=:" %%a in ('chcp') do set CPage=%%a
set CPage=%CPage: =%

call :SetMsgLang
for %%a in (%curl% %curlcrt% %grep% %sed% %p7z% %xml%) do if not exist %%a goto :NotAllBin

for /f "tokens=1-3 delims=." %%a in ('ver^|%grep% -Eo "[0-9]*\.[0-9]*\.[0-9]*"') do call :SetVerNum "%%a" "%%b" "%%c"
call :SetMsgLang

if not "%VerOS%"=="10" goto :Win10Only
if %VerBuild% lss %Min10Build% goto :Win10OldVer

rmdir /s /q "%~dp0Temp">nul 2>nul
mkdir "%~dp0Temp"

set FSNewVer=
%curl% -s -o "%~dp0Temp\%FNames%.appinstaller" "%RepURL%/%FNames%.appinstaller"
set XMLValid=1
for /f "tokens=*" %%a in ('cd.^|%xml% val -b "%~dp0Temp\%FNames%.appinstaller"') do set XMLValid=0
if "%XMLValid%"=="0" goto :AppInstBroken
for /f "tokens=*" %%a in ('cd.^|%xml% sel -t -v "//_:AppInstaller/@Version" "%~dp0Temp\%FNames%.appinstaller"') do set "FSNewVer=%%a"

set FSOldVer=
for /f "tokens=*" %%a in ('cd.^|%PS% "Get-AppxPackage -Name '%FSName%'|Select -Expand Version"') do set "FSOldVer=%%a"
call :SetMsgLang
if not "%FSOldVer%"=="" call :AlreadyInstalled

>nul 2>nul net session
if not errorlevel 1 goto :AlreadyAdmin
>nul 2>nul fsutil dirty query %systemdrive%
if errorlevel 1 goto :RunAsAdmin

:AlreadyAdmin
reg add "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\AppModelUnlock" /t REG_DWORD /v "AllowAllTrustedApps" /d 1 /f

echo %LNG_InstCer%
%curl% -# -o "%~dp0Temp\%FNames%.cer" "%RepURL%/%FNames%/%FNames%.cer"
certutil -enterprise -f -AddStore "Root" "%~dp0Temp\%FNames%.cer"

echo.
echo %LNG_NetIso%
CheckNetIsolation LoopbackExempt -a -n="%FSName%_%FSCSuf%"

set MFPName=
for /f "tokens=1" %%a in ('dism /Online /Get-Capabilities /Format:Table /English^|findstr /i /c:"MediaFeaturePack"^|findstr /i /c:"Not Present"') do set "MFPName=%%a"
if "%MFPName%"=="" goto :MFPIsHere
echo.
echo %LNG_InstMFP%
dism /Online /Add-Capability /CapabilityName:"%MFPName%" /NoRestart
if "%ERRORLEVEL%"=="3010" goto :RestartWindows
if not "%ERRORLEVEL%"=="0" goto :MFPError

:MFPIsHere
set "AppxName=%FNames%.appxbundle"
echo.
if %VerBuild% lss %MinAIBuild% goto :ManualInstall
%PS% "Get-AppxPackage -Name '%AIName%'"|findstr /i /l /c:"%AIName%">nul
if not errorlevel 1 goto :AppInstaller

echo %LNG_NoAppInst%
:ManualInstall
echo %LNG_ManInst%
set "Arch=x64"
if /i "%PROCESSOR_ARCHITECTURE%"=="x86" (if not defined PROCESSOR_ARCHITEW6432 set "Arch=x86")
%curl% -# -o "%~dp0Temp\%FNames%.appxbundle" "%RepURL%/%FNames%/%AppxName%"
%p7z% t -bso0 "%~dp0Temp\%FNames%.appxbundle"
if errorlevel 2 goto :BrokenFiles
%p7z% e -bso0 -y -o"%~dp0Temp" "%~dp0Temp\%FNames%.appxbundle" "%FNames%.*_%Arch%.appx"
%p7z% e -bso0 -y -o"%~dp0Temp" "%~dp0Temp\%FNames%.*_%Arch%.appx" "AppxManifest.xml"
for /f "tokens=*" %%a in ('cd.^|%xml% sel -t -v "//_:PackageDependency/@Name" "%~dp0Temp\AppxManifest.xml"') do call :InstallDepend "%%~a"
%PS% "Add-AppxPackage -Path '%~dp0Temp\%FNames%.appxbundle'"
rmdir /s /q "%~dp0Temp">nul 2>nul
goto :AppIsOK

:InstallDepend
echo Install dependencies: "%~1"...
:RetryGetLink
del /f /q "%~dp0Temp\*.appx" >nul 2>nul
set AllOK=1
for /f "tokens=*" %%b in ('cd.^|%curl% -s -F "type=PackageFamilyName" -F "url=%~1_%StoreSuf%" -F "ring=Retail" -F "lang=ru" "https://store.rg-adguard.net/api/GetFiles"^|%grep% -iF "http://tlu."^|%grep% -iF -e "_%Arch%__"^|%grep% -iEo "http:[^""]*"^|%sed% "s/%%/#/g"') do call :GetDepLink %1 "%%~b"
if "%AllOK%"=="0" goto :RetryGetLink
goto :eof

:GetDepLink
if %2=="" (goto :NoLink) else for /f "tokens=*" %%c in ('echo.%2^|%sed% "s/#/%%/g"') do %curl% -# -o "%~dp0Temp\%~1.appx" %%c
%p7z% t -bso0 "%~dp0Temp\%~1.appx"
if errorlevel 2 goto :BrokenFiles
%PS% "Add-AppxPackage -Path '%~dp0Temp\%~1.appx'"
goto :eof
:NoLink
set AllOK=0
goto :eof

:AppInstaller
call :MessageBox "%LNG_TitAppInst%" "%LNG_TxtAppInst%" 36
if not "%ERRORLEVEL%"=="6" goto :ManualInstall
echo %LNG_AppInstGo%
start "" /w "%~dp0Temp\%FNames%.appinstaller"
echo %LNG_AppInstExit%
timeout /t 5 >nul
goto :eof

:SetVerNum
set "VerOS=%~1"
set "VerSP=%~2"
set "VerBuild=%~3"
goto :eof

:SetMsgLang
if not "%CPage%"=="866" goto :LangEng

set "LNG_InstCer=稢  ⠭ 䨪..."
set "LNG_NetIso= FSClient   loopback-䥩..."
set "LNG_InstMFP=㦥 N- Windows. ⠭ MediaFeaturePack..."
set "LNG_NoAppInst= AppInstaller (LTSC  ᡮઠ)! 㦭 ⠭ ..."
set "LNG_ManInst=⠭ ਫ  ( AppInstaller)..."
set "LNG_OldWin=ॢ  Win 10 (%VerOS%.%VerSP%.%VerBuild%). ⠢ ..."
set "LNG_TitWinRest=ॡ १㧪"
set "LNG_TxtWinRest=MediaFeaturePack ⠭.\n 砭 ⠭ ॡ १㧨 .\n\n롥 ''  १㧪  '', ⮡ १㧨 .\n\n᫥ १㧪  ⠭騪 ᭮."
set "LNG_TitMFPE%=訡 ⠭"
set "LNG_TxtMFPE%=訡 ⠭ MediaFeaturePack!\n\n஢ 祭  ୥\n ஡ ᭮ ."
set "LNG_TitAppInst=AppInstaller "
set "LNG_TxtAppInst= ⥬  AppInstaller.\n\n⠭    (४) - \n筠 ⠭ - "
set "LNG_AppInstGo=⠭ ਫ १ AppInstaller..."
set "LNG_AppInstExit=⠭ १ AppInstaller 樨஢. 室  ਯ..."
set "LNG_TitNoBin=⨫  "
set "LNG_TxtNoBin= 㦭 ⨫    ⠫ 'bin'!\n\nᯠ 娢 楫!"
set "LNG_TitAIBroken= ०"
set "LNG_TxtAIBroken= .appinstaller ०   !\n\n஡   ࠧ ( )!"
set "LNG_TitAppUpdate= ਫ"
set "LNG_TxtAppUpdate= ⥬ ⠭ FS Client %FSOldVer%.\n\n   ᨨ %FSNewVer%?"
set "LNG_TitInstalled=ਫ 㦥 ⠭"
set "LNG_TxtInstalled=FS Client %FSOldVer% 㦥 ⠭  ⥬!\n\n஡ ⠭ ᭮?"
set "LNG_Tit10Only=ᮢ⨬  Windows"
set "LNG_Txt10Only=FS Client ⮫쪮  Windows 10!\n\n  - %VerOS%.%VerSP%.%VerBuild%"
set "LNG_TitOld10=ᮢ⨬  Windows"
set "LNG_TxtOld10=FS Client ⮫쪮  Windows 10 v%Min10Ver%  !\n(v%Min10Ver% = 10.0.%Min10Build%)\n\n  - %VerOS%.%VerSP%.%VerBuild%"
set "LNG_TitNoAdmin=筮 ࠢ"
set "LNG_TxtNoAdmin=室    !!!\n\n(ࠢ    CMD-䠩    㭪 )"
set "LNG_TitBroken= ०"
set "LNG_TxtBroken=  ᪠砫  ०!\n\n஡  ࠧ.\n( )"
set "LNG_TitAppOK=ਫ ⠭"
set "LNG_TxtAppOK=ਫ FS  ⠭.\n\n⭮ ᬮ!"
goto :eof

:LangEng
set "LNG_InstCer=Downloading and installing certificate..."
set "LNG_NetIso=Disable FSClient loopback isolation..."
set "LNG_InstMFP=Windows N-version detected. Installing MediaFeaturePack..."
set "LNG_NoAppInst=No AppInstaller (LTSC or shitbuild)! Must be installed manually..."
set "LNG_ManInst=Installing app manually (w/o AppInstaller)..."
set "LNG_OldWin=Old version of Win 10 (%VerOS%.%VerSP%.%VerBuild%). Installing manually..."
set "LNG_TitWinRest=Reboot required"
set "LNG_TxtWinRest=MediaFeaturePack installed.\nComputer needs reboot to finish installation.\n\nPress 'Yes' to reboot or 'No' to reboot later.\n\nAfter reboot run installer again."
set "LNG_TitMFPE%=Installation error"
set "LNG_TxtMFPE%=MediaFeaturePack installation error!\n\nCheck your internet connection\nor try again later."
set "LNG_TitAppInst=AppInstaller is found"
set "LNG_TxtAppInst=AppInstaller is in system.\n\nInstall via it (recommended) - Yes\nManual install - No"
set "LNG_AppInstGo=Installing application via AppInstaller..."
set "LNG_AppInstExit=Install via AppInstaller initiated. Script exiting..."
set "LNG_TitNoBin=Tools not found"
set "LNG_TxtNoBin=All required tools must be in 'bin' directory!\n\nUnpack entire archive!"
set "LNG_TitAIBroken=File damaged"
set "LNG_TxtAIBroken=File .appinstaller broken or not found!\n\nPlease try start again (or maybe later)!"
set "LNG_TitAppUpdate=Application update"
set "LNG_TxtAppUpdate=FS Client %FSOldVer% installed.\n\nUpdate it to version %FSNewVer%?"
set "LNG_TitInstalled=Already installed"
set "LNG_TxtInstalled=FS Client %FSOldVer% already installed!\n\nTry to reinstall?"
set "LNG_Tit10Only=Incompatible Windows"
set "LNG_Txt10Only=FS Client is for Windows 10 only!\n\nYour OS - %VerOS%.%VerSP%.%VerBuild%"
set "LNG_TitOld10=Incompatible Windows"
set "LNG_TxtOld10=FS Client is for Windows 10 v%Min10Ver% or newer!\n(v%Min10Ver% = 10.0.%Min10Build%)\n\nYour OS - %VerOS%.%VerSP%.%VerBuild%"
set "LNG_TitNoAdmin=No permissions"
set "LNG_TxtNoAdmin=Run as Administrator is needed!!!\n\n(right mouse click on CMD file and select such item)"
set "LNG_TitBroken=Broken files"
set "LNG_TxtBroken=No files downloaded or they broken!\n\nTry another time.\n(maybe later)"
set "LNG_TitAppOK=Application installed"
set "LNG_TxtAppOK=Application FS Client is installed.\n\nHave fun watching!"
goto :eof

:MessageBox
cscript //nologo /e:jscript "%~f0" %*
goto :eof

:NotAllBin
call :MessageBox "%LNG_TitNoBin%" "%LNG_TxtNoBin%" 16
exit

:AppInstBroken
call :MessageBox "%LNG_TitAIBroken%" "%LNG_TxtAIBroken%" 16
exit

:AlreadyInstalled
if "%FSOldVer%"=="%FSNewVer%" goto :SameVerInstall
call :MessageBox "%LNG_TitAppUpdate%" "%LNG_TxtAppUpdate%" 52
if not "%ERRORLEVEL%"=="6" exit
goto :eof
:SameVerInstall
call :MessageBox "%LNG_TitInstalled%" "%LNG_TxtInstalled%" 292
if not "%ERRORLEVEL%"=="6" exit
goto :eof

:Win10Only
call :MessageBox "%LNG_Tit10Only%" "%LNG_Txt10Only%" 16
exit

:Win10OldVer
call :MessageBox "%LNG_TitOld10%" "%LNG_TxtOld10%" 16
exit

:RunAsAdmin
call :MessageBox "%LNG_TitNoAdmin%" "%LNG_TxtNoAdmin%" 16
exit

:RestartWindows
call :MessageBox "%LNG_TitWinRest%" "%LNG_TxtWinRest%" 52
if not "%ERRORLEVEL%"=="6" exit
shutdown /r /t 0
exit

:MFPError
call :MessageBox "%LNG_TitMFPE%" "%LNG_TxtMFPE%" 16
exit

:BrokenFiles
call :MessageBox "%LNG_TitBroken%" "%LNG_TxtBroken%" 16
exit

:AppIsOK
call :MessageBox "%LNG_TitAppOK%" "%LNG_TxtAppOK%" 64 5
exit


*/

var Args=WScript.Arguments;
var WSh = new ActiveXObject ("WScript.Shell");
var res = (Args.length == 4 ? Args(3) : 0);
res = WSh.Popup(Args(1).replace(/\\n/g, String.fromCharCode(13)), res, Args(0), Args(2));
WScript.Quit(res);
